diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index 59e047386..fc844e0c7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -4,14 +4,16 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
 import net.minecraft.core.world.pos.ChunkSectionTilePos;
+import net.minecraft.core.world.pos.ChunkSectionTilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.nio.ByteBuffer;
 import java.nio.ShortBuffer;
@@ -41,11 +43,11 @@ public class ChunkSection {
         this.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
-        Arrays.fill(this.biome, (byte)-1);
+        Arrays.fill(this.biome, (byte) -1);
     }
 
-    public static int makeBlockIndex(final @NotNull ChunkSectionTilePos sectionPos) {
-        return (sectionPos.y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z * Chunk.CHUNK_SIZE_X) + sectionPos.x;
+    public static int makeBlockIndex(final @NotNull ChunkSectionTilePosc sectionPos) {
+        return (sectionPos.y() * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z() * Chunk.CHUNK_SIZE_X) + sectionPos.x();
     }
 
     @Deprecated
@@ -53,8 +55,8 @@ public class ChunkSection {
         return ChunkSection.makeBlockIndex(new ChunkSectionTilePos(x, y, z));
     }
 
-    public static int makeBiomeIndex(final @NotNull ChunkSectionTilePos sectionPos) {
-        return ((sectionPos.y >> 3) * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z * Chunk.CHUNK_SIZE_X) + sectionPos.x;
+    public static int makeBiomeIndex(final @NotNull ChunkSectionTilePosc sectionPos) {
+        return ((sectionPos.y() >> 3) * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X) + (sectionPos.z() * Chunk.CHUNK_SIZE_X) + sectionPos.x();
     }
 
     @Deprecated
@@ -62,7 +64,7 @@ public class ChunkSection {
         return ChunkSection.makeBiomeIndex(new ChunkSectionTilePos(x, y, z));
     }
 
-    public int getBlockId(final @NotNull ChunkSectionTilePos sectionPos) {
+    public int getBlockId(final @NotNull ChunkSectionTilePosc sectionPos) {
         if (!sectionPos.inBounds() || this.blocks == null) {
             return 0;
         }
@@ -75,7 +77,7 @@ public class ChunkSection {
         return this.getBlockId(new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setBlockId(final @NotNull ChunkSectionTilePos sectionPos, final int id) {
+    public void setBlockId(final @NotNull ChunkSectionTilePosc sectionPos, final int id) {
         assert id == 0 || Blocks.getBlock(id) != null;
 
         if (!sectionPos.inBounds() || (this.blocks == null && id == 0)) {
@@ -92,11 +94,11 @@ public class ChunkSection {
         this.setBlockId(new ChunkSectionTilePos(x, y, z), id);
     }
 
-    public int getData(final @NotNull ChunkSectionTilePos sectionPos) {
+    public int getData(final @NotNull ChunkSectionTilePosc sectionPos) {
         if (!sectionPos.inBounds() || this.blocks == null || this.data == null) {
             return 0;
         }
-        return this.data.get(sectionPos.x, sectionPos.y, sectionPos.z);
+        return this.data.get(sectionPos.x(), sectionPos.y(), sectionPos.z());
     }
 
     @Deprecated
@@ -104,14 +106,14 @@ public class ChunkSection {
         return this.getData(new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setData(final @NotNull ChunkSectionTilePos sectionPos, final int data) {
+    public void setData(final @NotNull ChunkSectionTilePosc sectionPos, final int data) {
         if (!sectionPos.inBounds() || this.blocks == null) {
             return;
         } else if (this.data == null) {
             this.data = new ChunkUnsignedByteArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
         }
 
-        this.data.set(sectionPos.x, sectionPos.y, sectionPos.z, data);
+        this.data.set(sectionPos.x(), sectionPos.y(), sectionPos.z(), data);
     }
 
     @Deprecated
@@ -119,7 +121,7 @@ public class ChunkSection {
         this.setData(new ChunkSectionTilePos(x, y, z), data);
     }
 
-    public @Nullable Biome getBiome(final @NotNull ChunkSectionTilePos sectionPos) {
+    public @Nullable Biome getBiome(final @NotNull ChunkSectionTilePosc sectionPos) {
         if (!sectionPos.inBounds()) {
             return null;
         }
@@ -143,7 +145,7 @@ public class ChunkSection {
         Arrays.fill(this.biome, (byte) biomeId);
     }
 
-    public void setBiome(final @NotNull ChunkSectionTilePos sectionPos, final @NotNull Biome biome) {
+    public void setBiome(final @NotNull ChunkSectionTilePosc sectionPos, final @NotNull Biome biome) {
         if (!sectionPos.inBounds()) {
             return;
         }
@@ -156,7 +158,7 @@ public class ChunkSection {
         this.setBiome(new ChunkSectionTilePos(x, y, z), biome);
     }
 
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePos sectionPos) {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos) {
         if (!sectionPos.inBounds()) {
             return 0;
         }
@@ -167,14 +169,14 @@ public class ChunkSection {
                     return 0;
                 }
 
-                return this.skylightMap.get(sectionPos.x, sectionPos.y, sectionPos.z);
+                return this.skylightMap.get(sectionPos.x(), sectionPos.y(), sectionPos.z());
             }
             case Block -> {
                 if (this.blocklightMap == null) {
                     return 0;
                 }
 
-                return this.blocklightMap.get(sectionPos.x, sectionPos.y, sectionPos.z);
+                return this.blocklightMap.get(sectionPos.x(), sectionPos.y(), sectionPos.z());
             }
             default -> {
                 return 0;
@@ -187,7 +189,7 @@ public class ChunkSection {
         return this.getBrightness(lightLayer, new ChunkSectionTilePos(x, y, z));
     }
 
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePos sectionPos, final int brightness) {
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkSectionTilePosc sectionPos, final int brightness) {
         if (!sectionPos.inBounds()) {
             return;
         }
@@ -198,14 +200,14 @@ public class ChunkSection {
                     this.skylightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
                 }
 
-                this.skylightMap.set(sectionPos.x, sectionPos.y, sectionPos.z, brightness);
+                this.skylightMap.set(sectionPos.x(), sectionPos.y(), sectionPos.z(), brightness);
             }
             case Block -> {
                 if (this.blocklightMap == null) {
                     this.blocklightMap = new ChunkNibbleArray(Chunk.CHUNK_SIZE_X, SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z);
                 }
 
-                this.blocklightMap.set(sectionPos.x, sectionPos.y, sectionPos.z, brightness);
+                this.blocklightMap.set(sectionPos.x(), sectionPos.y(), sectionPos.z(), brightness);
             }
         }
     }
@@ -215,7 +217,7 @@ public class ChunkSection {
         this.setBrightness(lightLayer, new ChunkSectionTilePos(x, y, z), brightness);
     }
 
-    public int getRawBrightness(final @NotNull ChunkSectionTilePos sectionPos, final int subtractedSkyLight) {
+    public int getRawBrightness(final @NotNull ChunkSectionTilePosc sectionPos, final int subtractedSkyLight) {
         if (!sectionPos.inBounds()) {
             return 0;
         }
@@ -236,17 +238,17 @@ public class ChunkSection {
         this.entities.remove(entity);
     }
 
-    public void getEntitiesWithin(final @Nullable Entity toExclude, final @NotNull AABB aabb, final @NotNull List<@NotNull Entity> entities) {
+    public void getEntitiesWithin(final @Nullable Entity toExclude, final @NotNull AABBdc aabb, final @NotNull List<@NotNull Entity> entities) {
         for (final @NotNull Entity e : this.entities) {
-            if (e != toExclude && e.bb.intersects(aabb)) {
+            if (e != toExclude && e.bb.intersectsAABB((AABBd) aabb)) {
                 entities.add(e);
             }
         }
     }
 
-    public <T extends Entity> void getEntitiesWithin(Class<T> ofClass, AABB aabb, List<@NotNull T> entities) {
+    public <T extends Entity> void getEntitiesWithin(@NotNull Class<T> ofClass, @NotNull AABBdc aabb, @NotNull List<@NotNull T> entities) {
         for (Entity e : this.entities) {
-            if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersects(aabb)) {
+            if (ofClass.isAssignableFrom(e.getClass()) && e.bb.intersectsAABB((AABBd) aabb)) {
                 //noinspection unchecked
                 entities.add((T) e);
             }
@@ -261,19 +263,19 @@ public class ChunkSection {
         world.unloadEntities(this.entities);
     }
 
-    public int setChunkSectionData(byte[] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex) {
+    public int setChunkSectionData(byte @NotNull [] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex) {
         int xSize = maxX - minX;
         int ySize = maxY - minY;
         int zSize = maxZ - minZ;
 
         // Read blocks
         if (data[startIndex++] == 1) {
-            if (blocks == null) {
-                blocks = new short[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
+            if (this.blocks == null) {
+                this.blocks = new short[Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z];
             }
 
-            ByteBuffer bb = ByteBuffer.allocate(blocks.length * 2);
-            bb.asShortBuffer().put(blocks);
+            ByteBuffer bb = ByteBuffer.allocate(this.blocks.length * 2);
+            bb.asShortBuffer().put(this.blocks);
 
             for (int cy = minY; cy < maxY; cy++) {
                 for (int cz = minZ; cz < maxZ; cz++) {
@@ -283,7 +285,7 @@ public class ChunkSection {
                 }
             }
 
-            ShortBuffer.wrap(blocks).put(bb.asShortBuffer());
+            ShortBuffer.wrap(this.blocks).put(bb.asShortBuffer());
 
 //            System.out.println("Wrote block array for x: " + chunk.xPosition + " y: " + yPosition + " z: " + chunk.zPosition);
         }
@@ -351,7 +353,7 @@ public class ChunkSection {
         return startIndex;
     }
 
-    public int getChunkSectionData(byte[] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex) {
+    public int getChunkSectionData(byte @NotNull [] data, int minX, int minY, int minZ, int maxX, int maxY, int maxZ, int startIndex) {
         int xSize = maxX - minX;
         int ySize = maxY - minY;
         int zSize = maxZ - minZ;
@@ -359,16 +361,16 @@ public class ChunkSection {
         // Create buffer to turn short IDs into bytes
         ByteBuffer bb = null;
         if (this.blocks != null) {
-            bb = ByteBuffer.allocate(blocks.length * 2);
-            bb.asShortBuffer().put(blocks);
+            bb = ByteBuffer.allocate(this.blocks.length * 2);
+            bb.asShortBuffer().put(this.blocks);
         }
 
         if (xSize * ySize * zSize == Chunk.CHUNK_SIZE_X * SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z) {
             // Write blocks
             if (this.blocks != null) {
                 data[startIndex++] = 1;
-                System.arraycopy(bb.array(), 0, data, startIndex, blocks.length * 2);
-                startIndex += blocks.length * 2;
+                System.arraycopy(bb.array(), 0, data, startIndex, this.blocks.length * 2);
+                startIndex += this.blocks.length * 2;
             } else {
                 data[startIndex++] = 0;
             }
@@ -410,7 +412,7 @@ public class ChunkSection {
             }
         } else {
             // Write blocks
-            if (blocks != null) {
+            if (this.blocks != null) {
                 data[startIndex++] = 1;
                 for (int cy = minY; cy < maxY; cy++) {
                     for (int cz = minZ; cz < maxZ; cz++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index d71e185b7..125eebb7a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -4,7 +4,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.ChunkPos;
-import net.minecraft.core.world.pos.ChunkTilePos;
+import net.minecraft.core.world.pos.ChunkTilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -26,8 +26,8 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
-        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
+    public int getBlockId(final @NotNull ChunkTilePosc tilePos) {
+        if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             return displayBlockId;
         }
 
@@ -35,8 +35,8 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
-        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
+    public int getBlockData(final @NotNull ChunkTilePosc tilePos) {
+        if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             return displayBlockMeta;
         }
 
@@ -44,33 +44,33 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
         return 15;
     }
 
     @Override
-    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
-        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
+    public boolean setTileEntity(final @NotNull ChunkTilePosc tilePos, final @NotNull TileEntity tileEntity) {
+        if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             displayTileEntity = tileEntity;
             displayTileEntity.worldObj = this.world;
-            displayTileEntity.x = tilePos.x;
-            displayTileEntity.y = tilePos.y;
-            displayTileEntity.z = tilePos.z;
+            displayTileEntity.x = tilePos.x();
+            displayTileEntity.y = tilePos.y();
+            displayTileEntity.z = tilePos.z();
         }
 
         return true;
     }
 
     @Override
-    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) {
-        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
+    public void removeTileEntity(final @NotNull ChunkTilePosc tilePos) {
+        if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             displayTileEntity = null;
         }
     }
 
     @Override
-    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
-        if (tilePos.x == displayBlockPosX && tilePos.y == displayBlockPosY && tilePos.z == displayBlockPosZ) {
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePosc tilePos) {
+        if (tilePos.x() == displayBlockPosX && tilePos.y() == displayBlockPosY && tilePos.z() == displayBlockPosZ) {
             return displayTileEntity;
         }
 
@@ -88,17 +88,17 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public double getBlockHumidity(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockHumidity(final @NotNull ChunkTilePosc tilePos) {
         return 0.5;
     }
 
     @Override
-    public double getBlockTemperature(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockTemperature(final @NotNull ChunkTilePosc tilePos) {
         return 0.5;
     }
 
     @Override
-    public double getBlockVariety(final @NotNull ChunkTilePos tilePos) {
+    public double getBlockVariety(final @NotNull ChunkTilePosc tilePos) {
         return 0.5;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index f235c6aab..3b5134788 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -2,13 +2,13 @@ package net.minecraft.core.world.chunk;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.ChunkPos;
-import net.minecraft.core.world.pos.ChunkTilePos;
+import net.minecraft.core.world.pos.ChunkTilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Arrays;
 import java.util.List;
@@ -38,40 +38,40 @@ public class EmptyChunk extends Chunk {
     public void recalcHeightmapAndLightmap() { }
 
     @Override
-    public int getBlockId(final @NotNull ChunkTilePos tilePos) {
+    public int getBlockId(final @NotNull ChunkTilePosc tilePos) {
         return 0;
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull ChunkTilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdData(final @NotNull ChunkTilePosc tilePos, final int id, final int data) {
         return true;
     }
 
     @Override
-    public boolean setBlockId(final @NotNull ChunkTilePos tilePos, final int id) {
+    public boolean setBlockId(final @NotNull ChunkTilePosc tilePos, final int id) {
         return true;
     }
 
     @Override
-    public int getBlockData(final @NotNull ChunkTilePos tilePos) {
+    public int getBlockData(final @NotNull ChunkTilePosc tilePos) {
         return 0;
     }
 
     @Override
-    public boolean setBlockData(final @NotNull ChunkTilePos tilePos, final int value) {
+    public boolean setBlockData(final @NotNull ChunkTilePosc tilePos, final int value) {
         return true;
     }
 
     @Override
-    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos) {
+    public int getBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos) {
         return 0;
     }
 
     @Override
-    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePos tilePos, final int value) { }
+    public void setBrightness(final @NotNull LightLayer lightLayer, final @NotNull ChunkTilePosc tilePos, final int value) { }
 
     @Override
-    public int getRawBrightness(final @NotNull ChunkTilePos tilePos, final int subtractedSkyLight) {
+    public int getRawBrightness(final @NotNull ChunkTilePosc tilePos, final int subtractedSkyLight) {
         return 0;
     }
 
@@ -85,12 +85,12 @@ public class EmptyChunk extends Chunk {
     public void removeEntityAtIndex(final @NotNull Entity entity, final int index) { }
 
     @Override
-    public boolean canBlockSeeSky(final @NotNull ChunkTilePos tilePos) {
+    public boolean canBlockSeeSky(final @NotNull ChunkTilePosc tilePos) {
         return false;
     }
 
     @Override
-    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePos tilePos) {
+    public @Nullable TileEntity getTileEntity(final @NotNull ChunkTilePosc tilePos) {
         return null;
     }
 
@@ -98,12 +98,12 @@ public class EmptyChunk extends Chunk {
     public void addTileEntity(final @NotNull TileEntity tileEntity) { }
 
     @Override
-    public boolean setTileEntity(final @NotNull ChunkTilePos tilePos, final @NotNull TileEntity tileEntity) {
+    public boolean setTileEntity(final @NotNull ChunkTilePosc tilePos, final @NotNull TileEntity tileEntity) {
         return false;
     }
 
     @Override
-    public void removeTileEntity(final @NotNull ChunkTilePos tilePos) { }
+    public void removeTileEntity(final @NotNull ChunkTilePosc tilePos) { }
 
     @Override
     public void onLoad() { }
@@ -115,10 +115,10 @@ public class EmptyChunk extends Chunk {
     public void setChunkModified() { }
 
     @Override
-    public void getEntitiesWithin(final Entity toExclude, final AABB aabb, final List<Entity> entities) { }
+    public void getEntitiesWithin(final @Nullable Entity toExclude, final @NotNull AABBdc aabb, final @NotNull List<@NotNull Entity> entities) { }
 
     @Override
-    public <T extends Entity> void getEntitiesWithin(final Class<T> ofClass, final AABB aabb, final List<@NotNull T> entities) { }
+    public <T extends Entity> void getEntitiesWithin(final @NotNull Class<T> ofClass, final @NotNull AABBdc aabb, final @NotNull List<T> entities) { }
 
     @Override
     public boolean needsSaving(final boolean saveImmediately) {
@@ -126,7 +126,7 @@ public class EmptyChunk extends Chunk {
     }
 
     @Override
-    public int setChunkData(final byte[] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
+    public int setChunkData(final byte @NotNull [] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
                             final int startIndex) {
         final int dx = maxX - minX;
         final int dy = maxY - minY;
@@ -136,7 +136,7 @@ public class EmptyChunk extends Chunk {
     }
 
     @Override
-    public int getChunkData(final byte[] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
+    public int getChunkData(final byte @NotNull [] data, final int minX, final int minY, final int minZ, final int maxX, final int maxY, final int maxZ,
                             final int startIndex) {
         final int dx = maxX - minX;
         final int dy = maxY - minY;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
index 6b8a1395c..7696e8930 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/provider/ChunkProviderThreaded.java
@@ -2,7 +2,6 @@ package net.minecraft.core.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
-import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.ProgressListener;
@@ -18,8 +17,6 @@ import org.slf4j.Logger;
 import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Collection;
-import java.util.HashMap;
-import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Map;
@@ -238,22 +235,15 @@ public class ChunkProviderThreaded implements IChunkProvider {
         ChunkPos pos = chunk.pos;
         if (!chunk.isTerrainPopulated && isChunkValid(pos)) {
             synchronized (this.loadedChunks) {
-                ChunkPos northPos       = pos.add( 0, -1);
-                ChunkPos northEastPos   = pos.add( 1, -1);
-                ChunkPos eastPos        = pos.add( 1,  0);
-                ChunkPos southEastPos   = pos.add( 1,  1);
-                ChunkPos southPos       = pos.add( 0,  1);
-                ChunkPos southWestPos   = pos.add(-1,  1);
-                ChunkPos westPos        = pos.add(-1,  0);
-                ChunkPos northWestPos   = pos.add(-1, -1);
-                boolean northLoaded     = this.loadedChunks.containsKey(northPos);
-                boolean northEastLoaded = this.loadedChunks.containsKey(northEastPos);
-                boolean eastLoaded      = this.loadedChunks.containsKey(eastPos);
-                boolean southEastLoaded = this.loadedChunks.containsKey(southEastPos);
-                boolean southLoaded     = this.loadedChunks.containsKey(southPos);
-                boolean southWestLoaded = this.loadedChunks.containsKey(southWestPos);
-                boolean westLoaded      = this.loadedChunks.containsKey(westPos);
-                boolean northWestLoaded = this.loadedChunks.containsKey(northWestPos);
+                ChunkPos queryPos = new ChunkPos();
+                boolean northLoaded = this.loadedChunks.containsKey(pos.add(0, -1, queryPos));
+                boolean northEastLoaded = this.loadedChunks.containsKey(pos.add(1, -1, queryPos));
+                boolean eastLoaded = this.loadedChunks.containsKey(pos.add(1, 0, queryPos));
+                boolean southEastLoaded = this.loadedChunks.containsKey(pos.add(1, 1, queryPos));
+                boolean southLoaded = this.loadedChunks.containsKey(pos.add(0, 1, queryPos));
+                boolean southWestLoaded = this.loadedChunks.containsKey(pos.add(-1, 1, queryPos));
+                boolean westLoaded = this.loadedChunks.containsKey(pos.add(-1, 0, queryPos));
+                boolean northWestLoaded = this.loadedChunks.containsKey(pos.add(-1, -1, queryPos));
                 if (northLoaded && northEastLoaded && eastLoaded && southEastLoaded && southLoaded && southWestLoaded && westLoaded && northWestLoaded) {
                     decorate(chunk);
                     return true;
@@ -264,31 +254,24 @@ public class ChunkProviderThreaded implements IChunkProvider {
     }
 
     protected void checkForNeighborDecorations(@NotNull ChunkPos chunkPos) {
-        ChunkPos northPos       = chunkPos.add( 0, -1);
-        ChunkPos northEastPos   = chunkPos.add( 1, -1);
-        ChunkPos eastPos        = chunkPos.add( 1,  0);
-        ChunkPos southEastPos   = chunkPos.add( 1,  1);
-        ChunkPos southPos       = chunkPos.add( 0,  1);
-        ChunkPos southWestPos   = chunkPos.add(-1,  1);
-        ChunkPos westPos        = chunkPos.add(-1,  0);
-        ChunkPos northWestPos   = chunkPos.add(-1, -1);
+        ChunkPos queryPos = new ChunkPos();
         synchronized (this.positionsToCheckIfCanDecorate) {
             Chunk c;
-            c = this.loadedChunks.get(northPos);
+            c = this.loadedChunks.get(chunkPos.add(0, -1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(northEastPos);
+            c = this.loadedChunks.get(chunkPos.add(1, -1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(eastPos);
+            c = this.loadedChunks.get(chunkPos.add(1, 0, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(southEastPos);
+            c = this.loadedChunks.get(chunkPos.add(1, 1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(southPos);
+            c = this.loadedChunks.get(chunkPos.add(0, 1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(southWestPos);
+            c = this.loadedChunks.get(chunkPos.add(-1, 1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(westPos);
+            c = this.loadedChunks.get(chunkPos.add(-1, 0, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
-            c = this.loadedChunks.get(northWestPos);
+            c = this.loadedChunks.get(chunkPos.add(-1, -1, queryPos));
             if (c != null && !c.isTerrainPopulated) this.positionsToCheckIfCanDecorate.add(c);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
index ba5d71691..e4e790f6a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReaderVersion3.java
@@ -191,16 +191,6 @@ public class ChunkReaderVersion3
         }
 
         final @NotNull Int2ObjectMap<NextTickListEntry> entries = new Int2ObjectArrayMap<>();
-        for (final @NotNull Tag<?> tag : ticksTag) {
-            if (tag instanceof CompoundTag) {
-                final @NotNull CompoundTag tickTag = (CompoundTag) tag;
-                final @Nullable NextTickListEntry entry = NextTickListEntry.deserialize(tickTag);
-                if (entry != null) {
-                    final int compressed = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
-                    entries.put(compressed, entry);
-                }
-            }
-        }
 
         return entries;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
index d671296c8..6298ae49a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/writer/ChunkWriter.java
@@ -123,9 +123,6 @@ public class ChunkWriter
 
     public void putTickList(final @NotNull Int2ObjectMap<NextTickListEntry> entries) {
         final @NotNull ListTag ticksTag = new ListTag();
-        for (final @NotNull NextTickListEntry entry : entries.values()) {
-            ticksTag.addTag(NextTickListEntry.serialize(entry));
-        }
 
         this.tag.putList("TicksList", ticksTag);
     }
